package com.ruoyi.usernotice.service;

import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.usernotice.domain.UserNotice;
import com.ruoyi.usernotice.domain.bo.UserNoticeBo;
import com.ruoyi.usernotice.domain.vo.UserNoticeVo;

import java.util.Collection;
import java.util.List;

/**
 * C端用户通知Service接口
 *
 * @author ruoyi
 * @date 2025-04-21
 */
public interface IUserNoticeService {

    /**
     * 查询C端用户通知分页
     *
     * @param bo C端用户通知
     * @return C端用户通知集合
     */
    TableDataInfo<UserNoticeVo> queryPageList(UserNoticeBo bo, PageQuery pageQuery);

    /**
     * 查询C端用户通知列表
     *
     * @param bo C端用户通知
     * @return C端用户通知集合
     */
    List<UserNoticeVo> queryList(UserNoticeBo bo);

    /**
     * 查询C端用户通知
     *
     * @param id C端用户通知主键
     * @return C端用户通知
     */
    UserNoticeVo queryById(Long id);

    /**
     * 详情C端用户通知
     *
     * @param id C端用户通知主键
     * @return C端用户通知
     */
    UserNotice loadById(Long id, Boolean tw);

    /**
     * 新增C端用户通知
     *
     * @param bo C端用户通知
     * @return 结果
     */
    Boolean insertByBo(UserNoticeBo bo);

    /**
     * 修改C端用户通知
     *
     * @param bo C端用户通知
     * @return 结果
     */
    Boolean updateByBo(UserNoticeBo bo);

    /**
     * 校验并批量删除C端用户通知信息
     *
     * @param ids 需要删除的C端用户通知主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取用户消息数
     * @param userId
     * @param status
     * @return
     */
    Long queryUserCount(Long userId, Boolean status);

    Boolean setStatus(Long id);

    Boolean setAllStatus(Long userId);
}
